//-< Guess.java >----------------------------------------------------*--------*
// GOODS                     Version 1.0         (c) 1997  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
//                                                                   *  /  \  *
//                          Created:     16-Dec-2002  K.A. Knizhnik  * / [] \ *
//                          Last update: 16-Dec-2002  K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Example program: game "Guess an animal". 
//-------------------------------------------------------------------*--------*
using System;
using Goods;


[Metaobject(typeof(OptimisticMetaobject))]
public class Guess:Persistent
{
    Guess  yes;
    Guess  no;
    String question; 
	

    Guess(Metaobject mop) : base(mop) {}

    public Guess(Guess no, System.String question, Guess yes)
    {
        this.yes = yes;
        this.question = question;
        this.no = no;
    }
	
    internal static String input(String prompt)
    {
        while (true)
        {
            Console.Write(prompt);
            String s = Console.ReadLine();
            if (s.Length != 0) 
            { 
                return s;
            }
       }
    }
	
    internal static bool askQuestion(System.String question)
    {
        String answer = input(question);
        return answer.ToUpper().Equals("Y") || answer.ToUpper().Equals("YES");
    }
	
    internal static Guess whoIsIt(Guess parent)
    {
        System.String animal = input("What is it ? ");
        System.String difference = input("What is a difference from other ? ");
        return new Guess(parent, difference, new Guess(null, animal, null));
    }
	
    internal Guess dialog() 
    {
        if (askQuestion("May be, " + question + " (y/n) ? "))
        {
            if (yes == null)
            {
                System.Console.Out.WriteLine("It was very simple question for me...");
            }
            else
            {
                Guess clarify = yes.dialog();
                if (clarify != null)
                {
                    yes = clarify;
                    Modify();
                }
            }
        }
        else
        {
            if (no == null)
            {
                if (yes == null)
                {
                    return whoIsIt(this);
                }
                else
                {
                    no = whoIsIt(null);
                    Modify();
                }
            }
            else
            {
                Guess clarify = no.dialog();
                if (clarify != null)
                {
                    no = clarify;
                    Modify();
                }
            }
        }
        return null;
    }
	
    [STAThread]
    static public void  Main(System.String[] args)
    {
        Database db = new Database();
        Console.OpenStandardError();
        Console.OpenStandardInput();
        System.String cfgName = "guess.cfg";
        if (db.Open(cfgName))
        {
            Guess root = (Guess) db.Root;
			
            while (askQuestion("Think of an animal. Ready (y/n) ? "))
            {
                if (root == null)
                {
                    root = whoIsIt(null);
                    db.Root = root;
                }
                else
                {
                    root.dialog();
                }
            }
            Console.WriteLine("End of the game");
            db.Close();
        }
        else
        {
            Console.WriteLine("Failed to open database");
        }
    }
}


