//-< ClassDescriptor.java >------------------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// Java Program Interface                                            *  /  \  *
//                          Created:     15-Dec-2002  K.A. Knizhnik  * / [] \ *
//                          Last update: 15-Dec-2002  K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Attribute for specifying metaobject for the class
//-------------------------------------------------------------------*--------*
namespace Goods
{
    using System;
    using System.Runtime.Remoting.Contexts;
    using System.Runtime.Remoting.Messaging;
    using System.Runtime.Remoting;
    using System.Runtime.Remoting.Activation;
    using System.Runtime.CompilerServices;
  
    /// <summary>
    /// Attribute for specifying metaobject for the class
    /// </summary>
    [AttributeUsage(AttributeTargets.Class)]
    public class MetaobjectAttribute : ContextAttribute, IContributeObjectSink
    {
        /// <summary>
        /// Specify metaobject for the class 
        /// </summary>
        /// <param name="cls">metaobject class</param>
        ///
        public MetaobjectAttribute(Type cls) : base("GoodsMetaobjectProtocol") 
        {
            metaobject = (Metaobject)cls.GetConstructor(Type.EmptyTypes).Invoke(null);
;
        }
     
        public override bool IsContextOK(Context ctx, IConstructionCallMessage ctor) 
        {
            return false;//ctx.GetProperty("GoodsMetaobjectProtocol") != null;
        }
/*
        public override void GetPropertiesForNewContext(IConstructionCallMessage ctor) 
        {
            ctor.ContextProperties.Add(this);
        }
*/

        public IMessageSink GetObjectSink(MarshalByRefObject target, IMessageSink next) 
        {
            /*
            if (target is Persistent) 
            {
                Persistent obj = (Persistent)target;
                if ((obj.state & Persistent.CONSTRUCTING) != 0) 
                {
                    obj.state &= ~Persistent.CONSTRUCTING;
                    Console.Error.WriteLine("Post demon for constructor");
                    obj.metaobject.postDaemon(obj, Metaobject.CONSTRUCTOR | Metaobject.MUTATOR, true);  
                }
            } 
            */                   
            return new GoodsMessageSink(target, next);
        }

        public readonly Metaobject metaobject;
    }
}



