#include "../src/server.h"

storage_server* start_server()
{
 os_file*   odb_file = new os_file("pbtree.odb");
 os_file*   log_file = new os_file("pbtree.log");
 os_file*   his_file = new os_file("pbtree.his");
 mmap_file* idx_file = new mmap_file("pbtree.idx", 4*1024*1024);
 mmap_file* map_file = new mmap_file("pbtree.map", 8*1024*1024);

 object_manager*    obj_mgr = new object_manager(600);
 page_pool_manager* pool_mgr = new page_pool_manager(*odb_file, 4096);
 dbs_class_manager* class_mgr = new dbs_class_manager;
 gc_memory_manager* mem_mgr = new gc_memory_manager(*idx_file, *map_file,
                           True,
                           60,
                           0,
                           1024*1024,
                           time_t(0),
                           0,
                           1024,
                           fsize_t(0),
                           0,
                           24*60*60);

 log_transaction_manager* trans_mgr =
   new log_transaction_manager(*log_file, *his_file, NULL, true,
                               (transaction_manager::backup_type)
                               false,
                               fsize_t(8*1024)*1024,
                               fsize_t(0)*1024,
                               time_t(0),
                               time_t(600),
                               time_t(5),
                               0);

 storage_server *srv = new storage_server(0,
                           *obj_mgr,
                           *pool_mgr,
                           *class_mgr,
                           *mem_mgr,
                           *trans_mgr);
 srv->open("pbtree.cfg");
 return srv;
}
