//-< Server.java >---------------------------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// Java Program Interface                                            *  /  \  *
//                          Created:     23-Sep-2001  K.A. Knizhnik  * / [] \ *
//                          Last update: 23-Sep-2001  K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Class representing GOODS server process
//-------------------------------------------------------------------*--------*

package goodsjpi;

import java.io.*;

/**
 * Class for launching GOODS server process
 */
public class Server { 
    protected Process        process;
    protected PrintStream    pipeOut;
    protected BufferedReader pipeIn;
    protected String         cfgFileName;
   
    public Server(String cfgFileName) { 
	if (cfgFileName.endsWith(".cfg")) { 
	    cfgFileName = cfgFileName.substring(0, cfgFileName.length()-4);
	}
	this.cfgFileName = cfgFileName;
    }

    public void start()
    {
	try { 
	    process = Runtime.getRuntime().exec("goodsrv " + cfgFileName);
	    pipeOut = new PrintStream(process.getOutputStream());
	    pipeIn  = new BufferedReader(new InputStreamReader(process.getInputStream())); 
	} catch (Exception x) { 
	    x.printStackTrace();
	}
    }
	
    public BufferedReader command(String cmd) { 
	pipeOut.println(cmd);
	pipeOut.flush();
	return pipeIn;
    }

    public void stop() 
    { 
	try { 
	    command("exit");
	    //process.waitFor();
	} catch (Exception x) { 
	    x.printStackTrace();
	}
    }
}

