//-< ArrayOfObject.java >--------------------------------------------*--------*
// GOODS                      Version 2.04       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// GOODS Persistent Class Library                                    *  /  \  *
//                          Created:      5-Mar-99    K.A. Knizhnik  * / [] \ *
//                          Last update:  5-Mar-99    K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Dynamic array
//-------------------------------------------------------------------*--------*

package goodslib;
import  goodsjpi.*;

/**
 *  <code>AnyArray</code> is a base class for all array classes. It only serves
 * to hold the length (integer)
 *
 * @author K.A. Knizhnik
 */
public class AnyArray extends Persistent { 

  /**
   *  <code>used</code> holds the length of the array. The actual memory allocation
   * may be larger, but "used" many objects are seen from the outside
   */
  protected int used;

  /**
   *  <code>length</code> returns the length
   *
   * @return an <code>int</code> value, the length of the array
   */
  public int length() { 
        return used;
    }
}
