package org.dcg.datamgr;

import java.util.HashSet;

/**
 * This class is used to insert data into the database.</ br>
 * It can contain 1 or more objects to be inserted either in singular (1 by 1) or in bulk mode.</ br>
 * It is never allowed to be empty and the objects being inserted ALWAYS have to have MasterClass as their superClass.</ br>
 *
 * @author dacosta
 */
public class DataInsertionObject extends HashSet {
	private boolean _bulkLoad = false;
	private int _nrOfInstances = 0;
	
	public DataInsertionObject() {
		super();
	}
	
	/**
	 * Constructor to be used whenever one is to do a bulkload on 1 or more classes
	 */
	public DataInsertionObject(boolean bulkLoad, int nrOfInstances) {
		super();
		_bulkLoad = bulkLoad;
		_nrOfInstances = nrOfInstances;
	}
	
	/**
	 * Returns the bulkLoad.
	 * @return boolean
	 */
	public boolean isBulkLoad() {
		return _bulkLoad;
	}

	/**
	 * Returns the nrOfInstances to be inserted
	 * @return int
	 */
	public int getNrOfInstances() {
		return _nrOfInstances;
	}

}
