package org.dcg.datamgr.databasejobs;

import java.util.Iterator;

import org.dcg.datamgr.DataInsertionObject;
import org.dcg.datamgr.databasejobs.DatabaseJob;

/**
 * @author dacosta
 * 
 * Use this class (or a child thereof) to set the indexes for the respective classes.</br>
 * It is basically an admin issue so the 'normal' user NEVER gets exposed to this.</ br>
 * This class could be extended to also incorperate tasks like inserting instances for classes</ br>
 * that <em>HAVE to HAVE</em> an instance in the database BEFORE one can work with the class.</ br>
 */
public class DatabaseIndexJob extends DatabaseJob {
	DataInsertionObject _dataObject;

	public DatabaseIndexJob() {
	}

	/**
	 * @param data Object contains the classes that need to be indexed.<br>
	 */
	public DatabaseIndexJob(Object data) {
		_dataObject = (DataInsertionObject) data;
	}

	/**
	 * @aspect output
	 */
	public void run() {
		System.err.println("This method is NOT implemented.\nUse run(Database, Proot) instead");
	}

	synchronized protected void task2bExecuted() {
		Iterator iter = _dataObject.iterator();
		while (iter.hasNext()) {
			Class element = (Class) iter.next();
			insertClassIntoIndex(element);
		}
	}

	private void insertClassIntoIndex(Class class2bIndexed) {
	}
	
	public void setDatabaseParameters() {
	}

}
